# Tap Server
[![Test coverage](https://img.shields.io/coveralls/tmallfe/tapc-plugin-server.svg?style=flat-square)](https://coveralls.io/r/tmallfe/tapc-plugin-server?branch=master)
[![Build Status](https://travis-ci.org/tmallfe/tapc-plugin-server.png)](https://travis-ci.org/tmallfe/tapc-plugin-server)
[![Dependency Status](https://david-dm.org/tmallfe/tapc-plugin-server.svg)](https://david-dm.org/tmallfe/tapc-plugin-server)
[![devDependency Status](https://david-dm.org/tmallfe/tapc-plugin-server/dev-status.svg)](https://david-dm.org/tmallfe/tapc-plugin-server#info=devDependencies)
[![NPM version](http://img.shields.io/npm/v/tapc-plugin-server.svg?style=flat-square)](http://npmjs.org/package/tapc-plugin-server)
[![node](https://img.shields.io/badge/node.js-%3E=_4.0-green.svg?style=flat-square)](http://nodejs.org/download/)
[![License](http://img.shields.io/npm/l/tapc-plugin-server.svg?style=flat-square)](LICENSE)
[![npm download](https://img.shields.io/npm/dm/tapc-plugin-server.svg?style=flat-square)](https://npmjs.org/package/tapc-plugin-server)


## Install

```bash
$ tnpm install -g tapc
# 安装tap后默认安装tapc-plugin-server，无需手动安装
# $ tnpm install -g tapc-plugin-server
```

## Usage

```bash
$ tapc server # 启动本地服务
$ tapc server --debug # 开启debug模式
```
```bash
$ npm run build # build the source code with babel
$ npm run dev # build automatically when files change
$ npm run test # run unit tests
```


## Config

- tap.conf.js

```
module.exports = {
  server: {   // server配置
    commands: [ // 启动前的执行命令列表
      {
        command: 'ln a b'
      }
    ],
    workers: [ // 子任务管理列表
      {
        command: 'tapc monitor',
        monitor: 'success' //配置任务启动的监听信息,用于需要sudo等场景
      },
      {
        command: 'tapc assets' // 启动assets代理转发服务
      },
      {
        command: 'tapc preview' // 启动预览服务
      }
    ]
  }
};
```

## License

The MIT License (MIT)

Copyright (c) 2015 tmallfe

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
