'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _taskflow = require('./taskflow');

var _taskflow2 = _interopRequireDefault(_taskflow);

var _logger = require('./logger');

var _logger2 = _interopRequireDefault(_logger);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function actions(config, type, sync) {
  var debug = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;

  _logger2.default.info(util.inspect(config));
  var commands = config[type] || [];

  // 向下3.x兼容tap.conf.js配置处理
  if (type === 'workers' && config.monitor) {
    commands.unshift({
      command: 'tap monitor',
      monitor: '启动monitor成功'
    });
  }

  var commandNameList = commands.map(function (command) {
    return command ? command.command : '';
  });
  _logger2.default.debug(type + '\u7684\u547D\u4EE4\u5217\u8868: [' + commandNameList + ']');

  // 对tap扩展命令做特殊处理，过滤控制台的冗余提示信息
  commands.filter(function (command) {
    return (/^(tap|tapc) /.test(command.command)
    );
  }).forEach(function (command) {
    command.command += ' --ignoreCore';
    if (debug) {
      command.command += ' --debug';
    }
  });

  try {
    (0, _taskflow2.default)(commands, sync);
  } catch (err) {
    _logger2.default.error(err);
  }
}

function obsolutedActionHandler(prog) {
  var actionList = [{
    type: 'commands',
    sync: true
  }, {
    type: 'workers',
    sync: false
  }];
  actionList.forEach(function (action) {
    actions(prog.projectTapConfFile.server || prog.projectTapConfFile, action.type, action.sync, prog.parent.debug);
  });
}

function actionHandler(prog) {
  var tplDir = prog.projectTapConfFile.tplDir;
  var p = _path2.default.join(tplDir, 'package/scripts/server.js');
  require(p)(prog.projectTapConfFile.server, _logger2.default);
}

exports.default = {
  command: {
    name: 'server',
    description: '启动本地开发服务器',
    options: [],
    action: function action(prog) {
      _logger2.default.setDebug(prog.parent.debug);
      if (prog.projectTapConfFile.template) {
        // MUI 5
        actionHandler(prog);
      } else {
        obsolutedActionHandler(prog);
      }
    }
  }
};
module.exports = exports['default'];